<template lang="html">
  <div id="screenOverlay" class="screen-overlay" v-on:click="hide($event)">
    <slot></slot>
  </div>
</template>

<script>
import { mapActions } from 'vuex'

export default {
  name: 'ep-screen-overlay',
  data () {
    return { }
  },
  mounted () {
    this.disableScroll()
  },
  beforeDestroy () {
    this.enableScroll()
  },
  methods: {
    ...mapActions('app', [
      'closeDialog'
    ]),
    hide (e) {
      if (e.target.id !== 'screenOverlay') {
        return
      }

      this.closeDialog()
    },
    enableScroll () {
      document.getElementsByTagName('body')[0].style.overflow = 'visible'
    },
    disableScroll () {
      document.getElementsByTagName('body')[0].style.overflow = 'hidden'
    }
  }
}
</script>

<style lang="scss" scoped>
.screen-overlay {
  z-index: 10;
  position: fixed;
  width: 100%;
  height: 100%;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  background: rgba(0,0,0,0.85);

  * {
    position: relative;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }
}
</style>
